<template>
  <div class="sw-gs-offcanvas-cart sw-side-cart">
    <div v-if="count" key="my-cart" class="my-cart">
      <div class="collected-product-list">
        <SwPluginSlot name="gs-offcanvas-cart-products-before"/>
        <transition-group name="fade" tag="div" class="sw-gs-offcanvas-products">
          <SwGsCartProduct v-for="product in cartItems" :key="product.id" :product="product"/>
        </transition-group>
        <SwPluginSlot name="gs-offcanvas-cart-products-after"/>
      </div>

      <div class="sw-gs-offcanvas-cart-summary" :class="{isGuide, isClient}">
        <SfProperty :name="$t('Total price')" class="sf-property--full-width sf-property--large my-cart__total-price">
          <template #value>
            <SfPrice :regular="formatPrice(totalPrice, {separator: '.'})" class="sf-price--big"/>
          </template>
        </SfProperty>

        <SwPluginSlot name="gs-offcanvas-cart-checkout-page-button">
          <router-link v-if="isClient"
                       :to="checkoutRoute"
                       target="_blank"
                       class="sw-gs-offcanvas-cart-btn sf-button sf-button--full-width color-secondary">
            {{ $t("Go to checkout") }}
          </router-link>
        </SwPluginSlot>
      </div>
    </div>
    <div v-else-if="!currentClientCartPermissions && isGuide && allowUserActionsForGuide">
      <SfHeading :level="2"
                 class="empty-cart__heading"
                 :description="$t('You need to ask your client for his permission to edit his cart.')"/>
      <SwButton v-if="currentClientForGuide"
                class="sw-gs-offcanvas-cart-request-permissions"
                title="$t('Request cart permissons')"
                @click="requestTokenPermissions()">
        {{ $t('Request cart permissons') }}
      </SwButton>
    </div>
    <div v-else-if="isGuide && !allowUserActionsForGuide" key="empty-cart" class="empty-cart">
      <div class="empty-cart__banner">
        <SfHeading :title="$t('Your are not allowed to see clients cart')"
                   :level="2"
                   class="empty-cart__heading"/>
      </div>
    </div>
    <div v-else key="empty-cart" class="empty-cart">
      <div class="empty-cart__banner">
        <SfHeading :title="isClient ? $t('Your cart is empty') : $t('Your clients cart is empty')"
                   :level="2"
                   class="empty-cart__heading"
                   :description="isClient ? $t('No items in cart') : ''"/>
      </div>
    </div>
  </div>
</template>

<script>
  import {
    SfProperty,
    SfPrice,
    SfHeading,
  } from "@storefront-ui/vue"
  import {
    useUIState,
  } from "@shopware-pwa/composables"
  import SwGsCartProduct from "../SwGsCartProduct.vue"
  import SwButton from "@/components/atoms/SwButton.vue"
  import { PAGE_CHECKOUT } from "@/helpers/pages"
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import { computed, onMounted, ref } from "@vue/composition-api"
  import { usePriceFilter } from "../../logic/composables/usePriceFilter";
  import { useGsCart } from "../../logic/composables/useGsCart";
  import { useState } from "../../logic/composables/useState";
  import { useAppointment } from "../../logic/composables/useAppointment";

  export default {
    name: "SwGsCart",
    components: {
      SfHeading,
      SfProperty,
      SfPrice,
      SwGsCartProduct,
      SwPluginSlot,
      SwButton,
    },
    setup() {
      const { isClient, isGuide } = useAppointment();
      const { formatPrice } = usePriceFilter();
      const { currentClientForGuide, stateForAll } = useState();
      const { cartItems, count, totalPrice, currentClientCartPermissions, requestTokenPermissions } = useGsCart();
      const { isOpen: isSidebarOpen, switchState: toggleSidebar } = useUIState({ stateName: "GS_OFFCANVAS_SIDEBAR_STATE" })
      // Component is lazy loaded so to allow animation on first load it needs to be done after it is mounted
      const isComponentMounted = ref(false)

      onMounted(async () => {
        isComponentMounted.value = true
      });

      const sidebarState = computed(
        () => isSidebarOpen.value && isComponentMounted.value
      )

      const getCartProducts = computed(() => {
        return cartItems.value.filter((cartItem) => cartItem.type === "product")
      })

      return {
        isClient,
        isGuide,
        currentClientForGuide,
        requestTokenPermissions,
        currentClientCartPermissions,
        cartItems: getCartProducts,
        count,
        totalPrice,
        isSidebarOpen: sidebarState,
        toggleSidebar,
        formatPrice,
        allowUserActionsForGuide: computed(() => stateForAll.value?.allowUserActionsForGuide)
      }
    },

    computed: {
      checkoutRoute() {
        return this.$routing.getUrl(PAGE_CHECKOUT);
      },
    },
  }
</script>
<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-side-cart {
    --property-name-font-size: var(--font-size--lg);
    --property-value-font-size: var(--font-size--lg);
    --sidebar-bottom: var(--bottom-navigation-height, 0);
    --sidebar-bottom-padding: var(--spacer-sm) var(--spacer-sm) var(--spacer-xl);

    & > * {
      --sidebar-content-padding: 0 var(--spacer-xs) var(--spacer-xs) var(--spacer-xs);
    }

    @include for-desktop {
      --sidebar-bottom: 0;
      & > * {
        --sidebar-bottom-padding: var(--spacer-base);
        --sidebar-content-padding: 0 var(--spacer-base) var(--spacer-base) var(--spacer-base);
      }
    }
  }

  .my-cart {
    flex: 1;
    display: flex;
    flex-direction: column;

    &__total-items {
      display: none;
      margin: var(--spacer-xs) 0;
      @include for-desktop {
        display: block;
        margin: var(--spacer-xl) 0 var(--spacer-lg) 0;
        --property-name-font-weight: var(--font-weight--medium);
      }
    }

    &__total-price {
      --price-font-size: var(--font-size--xl);
      --price-font-weight: var(--font-weight--semibold);
      margin: 0 0 var(--spacer-base) 0;
    }
  }

  .collected-product-list {
    flex: 1;
  }

  .empty-cart {
    --heading-description-margin: 0 0 var(--spacer-xl) 0;
    --heading-title-margin: var(--spacer-base) 0;
    --heading-title-color: var(--c-primary);
    --heading-title-font-weight: var(--font-weight--semibold);
    display: flex;
    flex: 1;
    align-items: center;
    flex-direction: column;

    &__banner {
      display: flex;
      justify-content: center;
      flex-direction: column;
      align-items: center;
      flex: 1;
    }
  }

  .collected-product-list {
    padding-bottom: 150px; // prevent cut-off by summary div

    @include for-desktop {
      padding-bottom: 120px;
    }
  }

  .sw-gs-offcanvas-products {
    display: flex;
    flex-wrap: wrap;
    margin-left: calc(-1 * var(--spacer-2xs));
    margin-right: calc(-1 * var(--spacer-2xs));

    > div {
      flex-wrap: wrap;
      position: relative;
      width: 100%;
      flex: 0 0 50%;
      max-width: 50%;
      margin-bottom: 30px;
    }
  }

  .sw-gs-offcanvas-cart-summary {
    position: absolute;
    z-index: var(--helper-lay-over-sibling-z-index);
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
    width: calc(100% - 48px);
    padding: 24px 24px 84px 24px;
    background: var(--c-white);

    @include for-desktop {
      padding: 24px;
    }
  }

  .sw-gs-offcanvas-cart-btn:hover {
    color: var(--c-white);
  }

  .sw-gs-offcanvas-cart-request-permissions {
    margin: var(--spacer-sm) auto;
  }
</style>
